From compcert
Require Import RTL.
From Coq
Require Import Lia.

Lemma semantics_determinate:
  forall (p: program), Smallstep.determinate (semantics p).
Proof.
Ltac vauto := once (econstructor; eauto; (once (econstructor; eauto) || idtac)).
  intros p. constructor; simpl.
- intros s t1 s1 t2 s2 H H0.
  inversion H; clear H; inversion H0; clear H0; try subst; try discriminate;
  repeat match goal with
  | K : State _ _ _ _ _ _ = State _ _ _ _ _ _ |- _ => inversion K; clear K; try subst
  | K : Callstate _ _ _ _ = Callstate _ _ _ _ |- _ => inversion K; clear K; try subst
  | K : Returnstate _ _ _ = Returnstate _ _ _ |- _ => inversion K; clear K; try subst
  | E : ?a = ?b, E' : ?a' = ?b' |- _ => let K := fresh in assert (b = b') as K by congruence; clear E';
   try (inversion K; clear K); try subst
  | EBA : Events.eval_builtin_args _ _ _ _ _ ?v, EBA' : Events.eval_builtin_args _ _ _ _ _ _ |- _ =>
    pose proof (Events.eval_builtin_args_determ EBA EBA'); clear EBA'; subst v
  | EF : Events.external_call _ _ _ _ _ _ _, EF' : Events.external_call _ _ _ _ _ _ _ |- _ =>
    destruct (Events.external_call_determ _ _ _ _ _ _ _ _ _ _ EF EF'); intuition congruence
  end; vauto.
- intros s t s' H. inversion H; clear H; subst; simpl; try lia; eapply Events.external_call_trace_length; eauto.
- intros s1 s2 H H0. inversion H; clear H; inversion H0; clear H0; subst.
  subst ge0 ge. congruence.
- intros s r H t s' K. inversion H; clear H; subst; inversion K.
- intros s r1 r2 H H0; inversion H; clear H; inversion H0; congruence.
Qed.

