let () =
  let name = try Sys.argv.(1) with _ -> "qap.bin" in
  let ic = open_in_bin name in
  if try Sys.argv.(2) = "trace" with _ -> false
  then
    try
      while true do
        ic |> QapIO.input_zp |> MoreString.hex_of_N |> Camlcoq.camlstring_of_coqstring |> print_endline
      done
    with _ -> ()
  else
  QapIO.input_qap_bin ic
    (fun nroots bank_wires ->
       Array.iteri (fun i a ->
         Printf.printf "%d wires in bank %d:" (Array.length a) i;
         Array.iter (fun w ->
           Printf.printf " %d" w
         ) a;
         Printf.printf "\n"
       ) bank_wires;
       let nroots = Camlcoq.P.to_int nroots in
       Printf.printf "%d roots\n" (nroots - 1);
       Array.init nroots (fun r -> [| |])
    )
    (fun s p r w k ->
       Printf.printf "r: %s\tp: %d\tw: %s\tk: %s\n"
         (r |> MoreString.hex_of_pos |> Camlcoq.camlstring_of_coqstring)
         p
         (w |> MoreString.hex_of_pos |> Camlcoq.camlstring_of_coqstring)
         (k |> MoreString.hex_of_N |> Camlcoq.camlstring_of_coqstring);
       s
    )
    |> ignore
  ;
  close_in ic
