Require Import RField.
Import EquivDec.
Require Import modp.
Import BinInt Znumtheory.

Section FIELD.

Context p (PRIME: prime (Zpos p)).

Instance zpEquiv : EqDec (zp p) (@eq _) := @zp_dec p.
Instance zpPlus : Plus (zp p) := @add p.
Instance zpZero : Zero (zp p) := @zero p.
Instance zpOpp : Opposite (zp p) := @neg p.
Instance zpMult : Mult (zp p) := @mul p.
Instance zpOne : One (zp p) := @one p.
Instance zpInv : Inverse (zp p) := @inverse p.

Instance modp_field : @Field (zp p) _ _ _ _ _ _ _ _ _.
Proof.
econstructor.
- repeat intro; congruence.
- repeat intro; congruence.
- repeat intro; congruence.
- repeat intro; congruence.
- exact (@add_assoc p).
- exact (@add_comm p).
- exact (@mul_assoc p).
- exact (@mul_comm p).
- exact (@add_zero_l p).
- intro x. setoid_rewrite add_comm. exact (add_neg_r x).
- exact (@mul_one_l p).
- exact (@add_mul_distr_l p).
- exact (one_not_zero PRIME).
- intros x hnz. setoid_rewrite mul_comm. rewrite (inverse_correct PRIME). apply one_is_one, PRIME.
  intros K. apply hnz, zp_eq, Znat.N2Z.inj, K.
Qed.

End FIELD.
