{ stdenv, fetchFromGitHub, unzip, ecm, gmp, coq, bignums }:

stdenv.mkDerivation {
  name = "coq${coq.coq-version}-coqprime-8.8";
  src = fetchFromGitHub {
    owner = "thery";
    repo = "coqprime";
    rev = "v8.8";
    sha256 = "075yjczk79pf1hd3lgdjiz84ilkzfxjh18lgzrhhqp7d3kz5lxp5";
  };

  nativeBuildInputs = [ unzip ];
  buildInputs = [ ecm gmp coq ] ++ (with coq; [ ocaml camlp5 ]);
  propagatedBuildInputs = [ bignums ];

  configureScript = "./configure.sh";

  buildFlags = "all html";

  enableParallelBuilding = true;

  postBuild = "cd gencertif; make; cd ..";

  installFlags = [
    "COQLIBINSTALL=$(out)/lib/coq/${coq.coq-version}/user-contrib/"
    "COQDOCINSTALL=$(out)/share/doc/coq/${coq.coq-version}/user-contrib/"
  ];
  installTargets = [ "install" "install-doc" ];

  preInstall = ''
    mkdir -p $out/bin
    cp gencertif/pocklington $out/bin/
  '';

  meta = {
    homepage = http://coqprime.gforge.inria.fr/;
    license = stdenv.lib.licenses.lgpl21;
  };
}
